#include <bits/stdc++.h>

using namespace std;

struct Matching
{
    int m, n;
    vector<int> l, r;
    vector<bool> vis, ok;
    vector<vector<int>> adj;

    Matching(int m, int n) : m(m), n(n), l(n), r(m), vis(m), ok(m), adj(m) {}

    void clear()
    {
        for(int i=0; i<n; i++)
            adj[i].clear();
    }

    void addEdge(int x, int y)
    {
        adj[x].push_back(y);
    }

    bool pairUp(int v)
    {
        if(vis[v]) return false;
        vis[v] = true;

        for(auto u : adj[v])
            if(l[u] == -1) return l[u] = v, r[v] = u, true;

        for(auto u : adj[v])
            if(pairUp(l[u])) return l[u] = v, r[v] = u, true;

        return false;
    }

    int matching()
    {
        int sz;
        bool changed;

        l.assign(n, -1);
        r.assign(m, -1);

        for(sz=0, changed=true; changed; )
        {
            vis.assign(m, false);
            changed = false;

            for(int i=0; i<m; i++)
                if(r[i] == -1 && pairUp(i)) ++sz, changed = true;
        }

        return sz;
    }
};

int t, n;

int a[10005];
int b[10005];

Matching g = Matching(1, 1);




bool ok(int minDif)
{
    g.clear();

    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
            if(abs(a[i] - b[j]) >= minDif)
            {
                //cout<<"m add "<<i<<' '<<j<<'\n';
                g.addEdge(i, j);
            }

    //cout<<"match is "<<match()<<'\n';
    return g.matching() == n;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin>>t;
    while(t)
    {
        t--;

        cin>>n;

        for(int i=1;i<=n;i++)
            cin>>a[i];

        for(int i=1;i<=n;i++)
            cin>>b[i];

        g = Matching(n+1, n+1);

        //cout<<ok(11)<<'\n';
        //return 0;

        int st=0, dr=1e9, mij, last = 0;

        while(st <= dr)
        {
            mij = (st+dr)/2;

            if( ok(mij) )
            {
                last = mij;
                st = mij+1;
            }

            else
                dr = mij-1;
        }

        cout<<last<<'\n';
    }
    return 0;
}